#!/bin/bash

# 安裝套件
yum install -y gcc glibc glibc-common make net-snmp openssl-devel perl-CPAN bc
useradd -M -s /sbin/nologin nagios
cpan YAML
cpan -i Net::SNMP
cd /usr/local/src/
wget http://nagios-plugins.org/download/nagios-plugins-2.3.1.tar.gz
wget http://downloads.sourceforge.net/project/nagios/nrpe-2.x/nrpe-2.15/nrpe-2.15.tar.gz
tar -zxf nagios-plugins-2.3.1.tar.gz
tar -zxf nrpe-2.15.tar.gz
cd /usr/local/src/nagios-plugins-2.3.1
./configure
make
make install

cd /usr/local/src/nrpe-2.15
if [ -e /etc/redhat-release ]; then
    ./configure
else
    ./configure --with-ssl-lib=/usr/lib/x86_64-linux-gnu/
fi
make all
make install-plugin
make install-daemon
make install-daemon-config
make all
make install-plugin
make install-daemon
make install-daemon-config

rm -rf /usr/local/src/nagios-plugins-* /usr/local/src/nrpe-*

# 調整防火牆
#iptables -A INPUT -s 122.147.183.4 -p tcp --dport 5666 -j ACCEPT
#iptables -A INPUT -s 103.17.8.253 -p tcp --dport 5666 -j ACCEPT
#iptables -A INPUT -s 10.100.2.40 -p tcp --dport 5666 -j ACCEPT


# 抓取 nrpe 以及監控的程式 perl script
rm -f /usr/local/nagios/libexec/check_snmp_*
rm -f /usr/local/nagios/etc/nrpe.cfg

wget -O /usr/local/nagios/libexec/check_snmp_storage.pl https://cpanel.net.tw/tool/nagios/check_snmp_storage.txt
wget -O /usr/local/nagios/libexec/check_snmp_load.pl https://cpanel.net.tw/tool/nagios/check_snmp_load.txt
wget -O /usr/local/nagios/libexec/check_raid.pl https://cpanel.net.tw/tool/nagios/check_raid.txt
wget -O /usr/local/nagios/libexec/check_megaraid_sas https://cpanel.net.tw/tool/nagios/check_megaraid_sas.txt
wget -O /usr/local/nagios/libexec/check_megaraid_sas2 https://cpanel.net.tw/tool/nagios/check_megaraid_sas2.txt
wget -O /usr/local/nagios/libexec/check_queue https://cpanel.net.tw/tool/nagios/check_queue.txt
wget -O /usr/local/nagios/libexec/check_port.pl https://cpanel.net.tw/tool/nagios/check_port.txt
wget -O /usr/local/nagios/libexec/check_iostat https://cpanel.net.tw/tool/nagios/check_iostat.txt
wget -O /usr/local/nagios/libexec/check_net_traffic.sh https://cpanel.net.tw/tool/nagios/check_net_traffic.txt
wget -O /usr/local/nagios/libexec/check_swap.sh https://cpanel.net.tw/tool/nagios/check_swap.txt
wget -O /usr/local/nagios/libexec/check_memory.py https://cpanel.net.tw/tool/nagios/check_memory.txt
wget -O /usr/local/nagios/libexec/check_csf.sh https://cpanel.net.tw/tool/nagios/check_csf.txt
wget -O /usr/local/nagios/libexec/check_nis https://cpanel.net.tw/tool/nagios/check_nis.txt

chmod 500 /usr/local/nagios/libexec/* -R

wget -O /usr/local/nagios/etc/nrpe.cfg https://cpanel.net.tw/tool/nagios/nrpe.txt
chmod 644 /usr/local/nagios/etc/nrpe.cfg
chown nagios.nagios -R /usr/local/nagios/

# 執行 visudo 指令新增設定
echo 'nagios ALL = NOPASSWD: /sbin/MegaCli, /usr/sbin/exim, /usr/local/nagios/libexec/check_megaraid_sas2, /sbin/iptables, /bin/ps' >> /etc/sudoers

# 抓取 init 以及設定開機啟動

wget -O /etc/init.d/nrpe https://cpanel.net.tw/tool/nagios/initnrpe.txt
chmod 755 /etc/init.d/nrpe
/etc/init.d/nrpe start

chmod +x /etc/rc.d/rc.local
echo '/usr/local/nagios/bin/nrpe -c /usr/local/nagios/etc/nrpe.cfg -4 -d'>> /etc/rc.d/rc.local

ps aux |grep nrpe
netstat -tulnp | grep 5666

